package jsug.javafx;


// simple sequence creation
println(["foo", "bar"]); // => [foo, bar]
//var x: String[] = ["foo", "bar"];

// same with nested sequences (will be flattened)
println(["foo", ["bar"]]); // => [foo, bar]

// access via index
println(["first", "second", "third"][1]); // => "second"

// special sizeof operator
println(sizeof [0, 1, 2]); // => 3

// create range
println([0..3]); // => [0, 1, 2, 3]

// manually set step size
println([0..6 step  2]); // => [ 0, 2, 4, 6 ]
println([6..0 step -2]); // => [ 6, 4, 2, 0 ]

// use list comprehension functionality
println([0..5][x | x mod 2 == 0]); // => [0, 2, 4]

// manipulate sequences with insert/delete
var x = [0, 2];
insert 3 into x;
println(x); // => [0, 2, 3]
insert 1 before x[1]; // after x[0]
println(x); // => [0, 1, 2, 3]
delete 2 from x;
println(x); // => [0, 1, 3]
delete x[2];
println(x); // => [0, 1]
x = reverse x;
println(x); // => [1, 0]
delete x;
println(x); // => []

// sequence slices
var y = [0..4];
println(y[0..2]); // => [0, 1, 2]
println(y[0..<2]); // => [0, 1]
println(y[2..]); // => [2, 3, 4]
println(y[2..<]); // => [2, 3]

