package jsug.javafx.core;

// ------------------------------------------------
// bind value to string expression

var greeting = "Mr";
var name = "Johnson";

def x = bind "Hello {greeting} {name}!";
println(x); // => "Hello Mr Johnson!"

greeting = "Ms";
name = "Tailor";
println(x); // => "Hello Ms Tailor!"

// ------------------------------------------------
// bind value to an expression

var n = 8;
def y = bind {
    n / 2;
};
println(y); // => 4
n = 84;
println(y); // => 42


// ------------------------------------------------
// bind value to function

function f(x: Integer, y: Integer): Integer {
    x + y;
}

var v: Integer = 6;
var w: Integer = 4;
def z = bind f(v, w);
println(z); // => 10
v = 38;
println(z); // => 42


// ------------------------------------------------
// use triggers

var triggered: String = "N/A" on replace oldTriggered {
    println("triggered from [{oldTriggered}] to [{triggered}]");
}
// => "triggered from [] to [N/A]"
triggered = "new value"; // => "triggered from [N/A] to [new value]"



// ------------------------------------------------
// bind on objects ...
// ... see classes.fx

// ------------------------------------------------
// bound functions

var suffix: String = "MB";
bound function f2(x: Integer): String {
    "({x} {suffix})"
}
def suffixedNumber = bind f2(12);
println(suffixedNumber); // => "(12 MB)"
suffix = "GB";
println(suffixedNumber); // => "(12 GB)"

// ------------------------------------------------
// bind on sequences

var singled = [0..3];
var doubled = bind for(i in singled) i * 2;
println(doubled); // => [0, 2, 4, 6]
singled[3] = 21;
println(doubled); // => [0, 2, 4, 42]
