package jsug.javafx.core;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JButton;

// ------------------------------------------------
// define class with attributes and operations

class Person {
    public var name: String;
    public var age: Integer;

    public function printAttributes() {
        println("{this.name} is {this.age} years old.");
    }
}
def otto = Person {
    name: "Otto"
    age: 18
}
otto.printAttributes(); // => "Otto is 18 years old."


// ------------------------------------------------
// multiple inheritance

class X {
    var foo: String;
}
class Y {
    var bar: String;
    // foo: Integer ?! => compile error
}
class Z extends X, Y {

}
def z = Z {
    foo: "bar"
    bar: "foo"
}

// ------------------------------------------------
// abstract classes/methods

abstract class AbstractService {
    abstract function doSomething(): Void;
}

class ConcreteService extends AbstractService {
    override function doSomething(): Void {
        // doing stuff here
    }
}
def service: AbstractService = ConcreteService {};
service.doSomething();


// ------------------------------------------------
// visibility

class Visibilities {
    var onlyWithinFxFile; // script-private by default
    package var onlyWithinSamePackage;
    protected var onlyPackageAndInherited;
    public-read var readEverywhereWriteScriptPrivate;
    public-read package var readEverywhereWriteWithinPackage;
    public-init var readEverywhereWriteOnlyDuringCreation;
    // public-init var package ...
    public var everyoneEverything;
}


// ------------------------------------------------
// javafx and java

class MyListener extends ActionListener {
    override public function actionPerformed(evt: ActionEvent) {
        println("Action Performed");
    }
}
def btn: JButton = new JButton();
btn.addActionListener(MyListener {});
btn.doClick(); // => ""Action Performed""


// ------------------------------------------------
// binding on objects (or attributes only)

var myName = "Foo";
def p = bind Person {
    name: myName;
}
println(p.name); // => "Foo"
myName = "Bar"; // ... komplett neues objekt wird erzeugt!!!
println(p.name); // => "Bar"
/*
def p2 = Person {
    name: bind myName; ... person objekt bleibt gleich.
}
*/