package jsug.javafx.ui;


import javafx.animation.Interpolator;
import javafx.animation.Timeline;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.shape.ArcTo;
import javafx.scene.shape.MoveTo;
import javafx.scene.shape.Path;
import javafx.scene.effect.Lighting;
import javafx.scene.effect.light.DistantLight;


var x: Number;
var y: Number;

// setup x-movement
Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        at (0s) {x => 0.0},
        at (7s) {x => 387.0 tween Interpolator.LINEAR},
    ]
}.play();

// setup y-movement
Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse: true
    keyFrames: [
        at (0s) {y => 0.0},
        at (4s) {y => 55.0 tween Interpolator.LINEAR},
    ]
}.play();


def bgImage = ImageView{
    image: Image{
        url: "http://java.sun.com/docs/books/tutorial/2d/basic2d/examples/images/weather-sun.png"
    }
}


def cloud = Path {
    translateX: bind x
    translateY: bind y
    fill: Color.WHITE
    stroke: Color.LIGHTBLUE
    strokeWidth: 2
    effect: Lighting{light: DistantLight{azimuth: 90}}
    elements: [
        MoveTo { x: 15 y: 15 },
        ArcTo { x: 50 y: 10 radiusX: 20 radiusY: 20 sweepFlag: true},
        ArcTo { x: 70 y: 20 radiusX: 20 radiusY: 20 sweepFlag: true},
        ArcTo { x: 50 y: 60 radiusX: 20 radiusY: 20 sweepFlag: true},
        ArcTo { x: 20 y: 50 radiusX: 10 radiusY: 5 sweepFlag: true},
        ArcTo { x: 15 y: 15 radiusX: 10 radiusY: 10 sweepFlag: true},
    ]
}


Stage{
    title: "Cloud"
    visible: true
    scene: Scene {
        fill: Color.WHITE
        content: [ bgImage, cloud ]
    }
    onClose: function() {
        java.lang.System.exit(0);
    }
}

